-------------------------------------------------------------------------------
-- Harvest Counters
-- aJamDonut (aJamDonut) - 2016 - Reuse it, modify it, whatever - Have fun
-------------------------------------------------------------------------------

HC = HC or {}
HC.name = "HarvestCounter"

-- UI control: HarvestCounter

-- Check a val is in table
function SetContains(set, key)
    return set[key] ~= nil
end

function HC.CountItems()
	local b = 0 
	local r = 0
	local w = 0
	local c = 0
	local counted = {}
	local itemName = ''
	local slots = PLAYER_INVENTORY.inventories[INVENTORY_BACKPACK].slots
	for i,slot in pairs(slots) do
		if(type(i) == "number") then
			itemName = GetItemLinkName(INVENTORY_BACKPACK, i)
			if(not SetContains(counted, itemName)) then
				counted[i] = itemName
				
				if(GetItemType(INVENTORY_BACKPACK, i) == ITEMTYPE_WOODWORKING_RAW_MATERIAL) then
					w = w + GetItemTotalCount(INVENTORY_BACKPACK, i)
				end
				
				if(GetItemType(INVENTORY_BACKPACK, i) == ITEMTYPE_BLACKSMITHING_RAW_MATERIAL) then
					b = b + GetItemTotalCount(INVENTORY_BACKPACK, i)
				end
				
				if(GetItemType(INVENTORY_BACKPACK, i) == ITEMTYPE_CLOTHIER_RAW_MATERIAL) then
					c = c + GetItemTotalCount(INVENTORY_BACKPACK, i)
				end
				
				if(GetItemType(INVENTORY_BACKPACK, i) == ITEMTYPE_REAGENT) then
					r = r + GetItemTotalCount(INVENTORY_BACKPACK, i)
				end
			end
		end
	end
	HarvestCounterOre:SetText(string.format("Ore: %d", b))
	HarvestCounterWood:SetText(string.format("Wood: %d", w))
	HarvestCounterCloth:SetText(string.format("Cloth: %d", c))
	HarvestCounterFlowers:SetText(string.format("Flowers: %d", r))
	--   d("Flowers: "..r.." Ore: "..b.." Cloth: "..c.." Wood: "..w) # debug
end

function HC:RestorePosition()
	HarvestCounter:ClearAnchors()
	HarvestCounter:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, self.savedVariables.left, self.savedVariables.top)
end

function HC:Initialized()
	d("Starting harvest counter...")
	EVENT_MANAGER:RegisterForEvent(self.name, EVENT_LOOT_RECEIVED, self.Harvested) 
	self.savedVariables = ZO_SavedVars:New("HCSavedVariables", 1, nil, {})

	self:RestorePosition()
	self.CountItems()
end
function HC.OnAddOnLoaded(event, addonName)
	-- d(addonName)
	if addonName == HC.name then
		HC:Initialized()
	end
end

function HC.OnGUIMove()
	HC.savedVariables.left = HarvestCounter:GetLeft()
	HC.savedVariables.top = HarvestCounter:GetTop()
end

function HC.Harvested(eventCode, looter, itemLink, _, _, _, isMe)
	-- Only run when addon user picks loots (without this group events will re-run this)
	if (not isMe) then
		-- d("Twas: "..looter.." It was"..itemLink) # Cool thing that i might make an addon with
		return
	end
	HC.CountItems()
end

EVENT_MANAGER:RegisterForEvent(HC.name, EVENT_ADD_ON_LOADED, HC.OnAddOnLoaded)